package ca.uwo.csd.nlp;

import java.util.ArrayList;

public class Atom {

    private String name;
    private ArrayList<String> paramList;
    boolean negated;

    public Atom(boolean b) {
        name = null;
        paramList = new ArrayList<String>();
        negated = b;
    }

    public void add(String p) {
        paramList.add(p);
    }

    public void appendName(String s) {
        if (name == null) {
            name = s;
        } else {
            name += "_" + s;
        }
    }

    @Override
    public String toString() {
        StringBuilder tmp = new StringBuilder();
        if (negated) tmp.append("not ");
        tmp.append(name + "(");

        for (int i = 0; i < paramList.size(); i++) {
            if (i != 0) {
                tmp.append(",");
            }
            tmp.append(paramList.get(i));
        }
        tmp.append(")");
        return tmp.toString();
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getParam(int index)
    {
        if (index >= paramList.size()) {
            return null;
        }
        else {
            return paramList.get(index);
        }
    }


    public String postProcess()
    {
        String parts[] = name.split("_");
        ArrayList<String> tokens = new ArrayList<String>();
        for (int i = 0; i < parts.length; i++) {
            if (parts[i].equalsIgnoreCase("gene") || parts[i].equalsIgnoreCase("disease") || parts[i].equalsIgnoreCase("drug") || parts[i].equalsIgnoreCase("symptom")) {
                tokens.add(parts[i]);
            }
        }
        if (tokens.size() != 2 || paramList.size() != 2) {
            return null;
        }

        String s1 = tokens.get(0);
        String s2 = tokens.get(1);
        String tmp = null;
        String p1 = paramList.get(0);
        String p2 = paramList.get(1);

        if (s1.equalsIgnoreCase("symptom") || (s2.equalsIgnoreCase("gene") && !s1.equalsIgnoreCase("gene")) || (s1.equalsIgnoreCase("disease") && s2.equalsIgnoreCase("drug"))) {
            tmp = s1;
            s1 = s2;
            s2 = tmp;
            tmp = p1;
            p1 = p2;
            p2 = tmp;
        }

        String result = "";
        if (negated) result = "not ";
        result += s1 + "_" + s2 + "(" + p1 + "," + p2 + ")";
        return result;
    }
}
