/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ca.uwo.csd.nlp;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author tonatuni
 */
public class ClingoInterface {
    String database;
    String clingoPath;

    public ClingoInterface() {
        this.database = "database.lp";
        this.clingoPath = "clingo.exe";
    }

    public ClingoInterface(String database, String clingoPath) {
        this.database = database;
        this.clingoPath = clingoPath;
    }

    public ArrayList<String> getResult(ArrayList<ArrayList<Atom>> ruleList) throws Exception {

        generateLogicProgram(ruleList);
        String clingoCommand = clingoPath + " -t " + database + " tmp.lp " + " | grep \"^wh\" > output.txt";
        String command[] = {"cmd.exe", "/C", clingoCommand};

        ArrayList<String> result = new ArrayList<String>();
        Process p;
        try {
            p = Runtime.getRuntime().exec(command);
            p.waitFor();
            BufferedReader reader = new BufferedReader(new FileReader("output.txt"));
            String line = null;
            
            while ((line = reader.readLine()) != null) {
                line = line.substring(line.indexOf('(') + 1, line.indexOf(')'));
                result.add(line);
            }
            reader.close();
        } catch (InterruptedException ex) {
            throw new Exception("Clingo was interrupted while waiting for it.");
        } catch (IOException ex) {
            throw new Exception("Error occured while reading from output.txt: " + ex.getMessage());
        }

        return result;
    }
    private void generateLogicProgram(ArrayList<ArrayList<Atom>> ruleList) throws Exception {
        try {
            BufferedWriter writer = new BufferedWriter(new FileWriter("tmp.lp"));
            for (int i = 0; i < ruleList.size(); i++) {
                writer.write(ruleList.get(i).get(0).toString() + " :- ");
                for (int j = 1; j < ruleList.get(i).size(); j++) {
                    if (j > 1) writer.write(", ");
                    writer.write(ruleList.get(i).get(j).postProcess());
                }
                writer.write(".\n");
            }
            writer.close();
        } catch (IOException ex) {
            throw new Exception("Could not write tmp.lp");
        }
    }
}
