/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * GMain.java
 *
 * Created on 18-Apr-2011, 12:15:48 PM
 */

package ca.uwo.csd.nlp;

import ca.uwo.csd.nlp.QueryPreProcessor;
import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URI;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.AbstractAction;
import javax.swing.JComponent;
import javax.swing.KeyStroke;

/**
 *
 * @author tonatuni
 */
public class GMain extends javax.swing.JFrame {

    QueryPreProcessor preProcessor;
    Parser parser;
    DRSTranslator translator;
    APEInterface aPEInterface;
    ClingoInterface clingoInterface;
    String lastQuery;
    /** Creates new form GMain */
    public GMain() {
        initComponents();
        lastQuery = null;
        resultTextPane.setContentType("text/html");
        debugTextPane.setContentType("text/html");
        preProcessor = null;
        parser = new QParser();
        translator = new DRSTranslator();
        aPEInterface = new APEInterface();
        clingoInterface = new ClingoInterface();
        KeyStroke enter = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0);
        queryTextField.getInputMap(JComponent.WHEN_FOCUSED).put(enter, "pressedReturn");

        AbstractAction testAction = new AbstractAction() {
            public void actionPerformed(ActionEvent e) {
                showResult(queryTextField.getText());
            }
        };
        queryTextField.getActionMap().put("pressedReturn", testAction);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenu2 = new javax.swing.JMenu();
        jPanel1 = new javax.swing.JPanel();
        queryTextField = new javax.swing.JTextField();
        answerButton = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        resultPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        resultTextPane = new javax.swing.JTextPane();
        debugPanel = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        debugTextPane = new javax.swing.JTextPane();
        jMenuBar2 = new javax.swing.JMenuBar();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenu4 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();

        jMenu1.setText("File");
        jMenuBar1.add(jMenu1);

        jMenu2.setText("Edit");
        jMenuBar1.add(jMenu2);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("BQAS");

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        queryTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                queryTextFieldActionPerformed(evt);
            }
        });

        answerButton.setText("Answer");
        answerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                answerButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(61, 61, 61)
                .addComponent(queryTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 347, Short.MAX_VALUE)
                .addGap(32, 32, 32)
                .addComponent(answerButton)
                .addGap(20, 20, 20))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(28, 28, 28)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(queryTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(answerButton))
                .addContainerGap(36, Short.MAX_VALUE))
        );

        jTabbedPane1.setTabPlacement(javax.swing.JTabbedPane.BOTTOM);

        jScrollPane1.setViewportView(resultTextPane);

        javax.swing.GroupLayout resultPanelLayout = new javax.swing.GroupLayout(resultPanel);
        resultPanel.setLayout(resultPanelLayout);
        resultPanelLayout.setHorizontalGroup(
            resultPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 768, Short.MAX_VALUE)
            .addGroup(resultPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 768, Short.MAX_VALUE))
        );
        resultPanelLayout.setVerticalGroup(
            resultPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 261, Short.MAX_VALUE)
            .addGroup(resultPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(resultPanelLayout.createSequentialGroup()
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 261, Short.MAX_VALUE)
                    .addGap(0, 0, 0)))
        );

        jTabbedPane1.addTab("Result", resultPanel);

        jScrollPane2.setViewportView(debugTextPane);

        javax.swing.GroupLayout debugPanelLayout = new javax.swing.GroupLayout(debugPanel);
        debugPanel.setLayout(debugPanelLayout);
        debugPanelLayout.setHorizontalGroup(
            debugPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 768, Short.MAX_VALUE)
        );
        debugPanelLayout.setVerticalGroup(
            debugPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(debugPanelLayout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 261, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );

        jTabbedPane1.addTab("Deatail", debugPanel);

        jMenu3.setText("File");

        jMenuItem2.setText("Exit");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem2);

        jMenuBar2.add(jMenu3);

        jMenu4.setText("Show");

        jMenuItem1.setText("Show DRS in Browser");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem1);

        jMenuBar2.add(jMenu4);

        setJMenuBar(jMenuBar2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(141, 141, 141)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(119, 119, 119))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 773, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(60, 60, 60)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(36, 36, 36)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 289, Short.MAX_VALUE)
                .addGap(36, 36, 36))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void queryTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_queryTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_queryTextFieldActionPerformed

    private void answerButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_answerButtonActionPerformed
        // TODO add your handling code here:
        showResult(queryTextField.getText());
    }//GEN-LAST:event_answerButtonActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        try {
            // TODO add your handling code here:            
            if (lastQuery != null) {
                String url = aPEInterface.getLink(lastQuery, "drshtml");
                Desktop.getDesktop().browse(URI.create(url));
            }            
        } catch (IOException ex) {
            
        } 
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void showResult(String query) {
        StringBuilder resultText = new StringBuilder();
        StringBuilder debugText = new StringBuilder();
        try {
            if (preProcessor == null) {
                preProcessor = new QueryPreProcessor("drug.dic", "disease.dic", "gene.dic", "symptoms.dic");
            }
            query = preProcessor.preProcess(query);
            lastQuery = query;
            debugText.append("<b>Preprocessed Query:</b>&nbsp;&nbsp;" + query + "<br><br>");
            String queryDRS = aPEInterface.getDRS(query, "drs");
            
            if (queryDRS.startsWith("drs")) {
                debugText.append("<hr><b>DRS:</b> &nbsp;" + queryDRS + "<br><br>");
            } else {
                Pattern pat = Pattern.compile("value=(.)*\\?");
                Matcher mat = pat.matcher(queryDRS);
                if (mat.find()) {
                    debugText.append("<hr><b>APE Error:</b> &nbsp;" + mat.group() + "\"<br><br>");
                }
            }
            DRS drs = parser.parse(queryDRS);
            ArrayList<ArrayList<Atom>> ruleList = translator.translate(drs);

            debugText.append("<hr><b>Translated ASP Rules:</b><br>");
            for (ArrayList<Atom> l: ruleList) {
                debugText.append(l.get(0) + " :- ");
                for (int i = 1; i < l.size(); i++) {
                    if (i > 1) debugText.append(", ");
                    debugText.append(l.get(i));
                }
                debugText.append("<br><br>");
            }

            debugText.append("<hr><b>After Postprocessing:</b><br>");
            for (ArrayList<Atom> l: ruleList) {
                debugText.append(l.get(0) + " :- ");
                for (int i = 1; i < l.size(); i++) {
                    if (i > 1) debugText.append(", ");
                    debugText.append(l.get(i).postProcess());
                }
                debugText.append("<br><hr>");
            }
            ArrayList<String> result = clingoInterface.getResult(ruleList);
            if (result.isEmpty()) {
                resultText.append("No Result Found");
            } else {
                String color[] = {"F0F0F0", "FFFFFF"};
                resultText.append("<table width=100%>");
                for (int i = 0; i < result.size(); i++) {
                    String s = result.get(i);
                    resultText.append("<tr bgcolor='"+color[i%2] + "'<td>" + s + "</td></tr>");
                }
                resultText.append("</table>");
            }
        } catch (Exception ex) {
            resultText.append("No result found!(See Detail)");
            debugText.append(ex.getMessage());
        }
        resultTextPane.setText(resultText.toString());
        debugTextPane.setText(debugText.toString());
    }
    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GMain().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton answerButton;
    private javax.swing.JPanel debugPanel;
    private javax.swing.JTextPane debugTextPane;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuBar jMenuBar2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField queryTextField;
    private javax.swing.JPanel resultPanel;
    private javax.swing.JTextPane resultTextPane;
    // End of variables declaration//GEN-END:variables

}
