/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ca.uwo.csd.nlp;

import java.util.ArrayList;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author tonatuni
 */
public class Main {

    public static void main(String args[]) throws Exception {
        Parser p = new QParser();
        DRSTranslator tr = new DRSTranslator();
        APEInterface aPEInterface = new APEInterface();
        ClingoInterface clingoInterface = new ClingoInterface();        
        QueryPreProcessor preProcessor = new QueryPreProcessor("drug.dic", "disease.dic", "gene.dic", "symptoms.dic");
        Scanner in = new Scanner(System.in);
        while (true) {
            String line = in.nextLine();
            DRS drs = null;
            try {                
                line = preProcessor.preProcess(line);
                System.out.println("After pre processing: " + line);
                String drsStr = aPEInterface.getDRS(line, "drs");
                //System.out.println(drsStr);
                drs = p.parse(drsStr);
                if (drs == null) {
                    System.out.println("APE failed to parse the given query.");
                    continue;
                }
                ArrayList<ArrayList<Atom>> ruleList = tr.translate(drs);
                System.out.println(ruleList);
                ArrayList<String> result = clingoInterface.getResult(ruleList);
                if (result.isEmpty()) {
                    System.out.println("No result found");
                } else {
                    System.out.println(result);
                }

            } catch (Exception ex) {
                System.out.println("Error occured: " + ex.getMessage());
            }
            //System.out.println(drs);
        }
    }
}
