/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ca.uwo.csd.nlp;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author tonatuni
 */
public class QueryPreProcessor {
    final int DRUG = 0;
    final int DISEASE = 1;
    final int GENE = 2;
    final int SYMPTOM = 3;
    String drugDic;
    String diseaseDic;
    String geneDic;
    String symptomDic;
    HashMap<String, Integer> hashMap;
    
    public QueryPreProcessor(String drugDic, String diseaseDic, String geneDic, String symptomDic) throws Exception {
        this.drugDic = drugDic;
        this.diseaseDic = diseaseDic;
        this.geneDic = geneDic;
        this.symptomDic = symptomDic;

        hashMap = new HashMap<String, Integer>();
        ArrayList<String> fileNames = new ArrayList<String>();
        fileNames.add(drugDic);
        fileNames.add(diseaseDic);
        fileNames.add(geneDic);
        fileNames.add(symptomDic);

        for (int i = 0; i < fileNames.size(); i++) {
            try {
                BufferedReader in = new BufferedReader(new FileReader(fileNames.get(i)));
                String line = null;
                while ((line = in.readLine()) != null) {
                    hashMap.put(line, i);
                }
                in.close();
            } catch (IOException ex) {
                throw new Exception("Could not read from file " + fileNames.get(i) + ". " + ex.getMessage());
            }
        }
    }
    public String preProcess(String query) throws Exception {
        Pattern pat = Pattern.compile("[a-zA-Z0-9_]+");
        Matcher mat = pat.matcher(query);
        String newQuery = "";
        //boolean first = true;
        while (mat.find()) {
            String tmp = mat.group();
            if (tmp.equals("Which") || tmp.equals("What") || tmp.equals("Do") || tmp.equals("Does") || tmp.equals("Is") || tmp.equals("Are")) {
                tmp = tmp.toLowerCase();
            }
            char ch = tmp.charAt(0);
            if (Character.isUpperCase(ch)) {
                String tmp2 = tmp.toLowerCase();
                if (hashMap.get(tmp2) != null) {
                    int t = hashMap.get(tmp2);
                    switch (t) {
                        case DRUG:              tmp = "Drug_" + tmp;    break;
                        case DISEASE:           tmp = "Disease_" + tmp; break;
                        case GENE:              tmp = "Gene_" + tmp;    break;
                        case SYMPTOM:           tmp = "Symptom_" + tmp; break;
                    }
                } /*else {
                    throw new Exception("Unknown entity: " + tmp);
                }*/
            }
            newQuery += tmp + " ";
            //first = false;
        }
        newQuery += "?";
        return newQuery;
    }

}
