/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ca.uwo.csd.nlp.pred;

import java.util.ArrayList;

/**
 *
 * @author Syeed Ibn Faiz
 */
public class Verb extends Predicate {
    String ref;
    String verb;
    String subRef;
    String objRef;
    String indObjRef;
    boolean marked;
    boolean negated;

    public Verb(String ref, String verb, String subRef) {
        this.ref = ref;
        this.verb = verb;
        this.subRef = subRef;
        this.objRef = null;
        this.indObjRef = null;
        this.marked = false;
        this.negated = false;
    }

    public Verb(String ref, String verb, String subRef, String objRef) {
        this.ref = ref;
        this.verb = verb;
        this.subRef = subRef;
        this.objRef = objRef;
        this.indObjRef = null;
        this.marked = false;
        this.negated = false;
    }

    public Verb(String ref, String verb, String subRef, String objRef, String indObjRef) {
        this.ref = ref;
        this.verb = verb;
        this.subRef = subRef;
        this.objRef = objRef;
        this.indObjRef = indObjRef;
        this.marked = false;
        this.negated = false;
    }

    public Verb(ArrayList<String> l) {
        if (l.size() == 3) {
            this.ref = l.get(0);
            this.verb = l.get(1);
            this.subRef = l.get(2);
            this.objRef = null;
            this.indObjRef = null;
        } else if (l.size() == 4) {
            this.ref = l.get(0);
            this.verb = l.get(1);
            this.subRef = l.get(2);
            this.objRef = l.get(3);
            this.indObjRef = null;
        } else {
            this.ref = l.get(0);
            this.verb = l.get(1);
            this.subRef = l.get(2);
            this.objRef = l.get(3);
            this.indObjRef = l.get(4);
        }
        this.marked = false;
        this.negated = false;
    }
    @Override
    public String getRef() {
        return ref;
    }

    public String getIndObjRef() {
        return indObjRef;
    }

    public String getObjRef() {
        return objRef;
    }

    public boolean isNegated() {
        return negated;
    }

    public void setNegated(boolean negated) {
        this.negated = negated;
    }

    public String getSubRef() {
        return subRef;
    }

    public String getVerb() {
        return verb;
    }


    @Override
    public String toString() {
        if (indObjRef !=   null)
            return "Verb(" +  ref + "," + verb + "," + subRef + "," + objRef + "," + indObjRef + ')';
        else if (objRef != null)
            return "Verb(" +  ref + "," + verb + "," + subRef + "," + objRef + ')';
        else
            return "Verb(" +  ref + "," + verb + "," + subRef + ')';
    }

    public boolean isMarked() {
        return marked;
    }

    public void setMarked(boolean marked) {
        this.marked = marked;
    }

    @Override
    public String getType() {
        return "VRB";
    }

    

}
